﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;

namespace _289938_TreeViewContainerBindings
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
			this.treeView.ItemsSource = this.GenerateData();
		}

		private List<Company> GenerateData()
		{
			List<Company> result = new List<Company>();

			for (int i = 0; i < 2; i++)
			{
				Company c = new Company()
				{
					Name = String.Format("Company {0}", i)
				};

				for (int j = 0; j < 2; j++)
				{
					Department d = new Department()
					{
						Name = String.Format("Department {0}.{1}", i, j)
					};

					for (int k = 0; k < 2; k++)
					{
						Employee e = new Employee()
						{
							Name = String.Format("Employee {0}.{1}.{2}", i, j, k)
						};
						d.Employees.Add(e);
					}
					c.Departments.Add(d);
				}
				result.Add(c);
			}
			return result;
		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			string searchItem = textBox.Text;
			string path = "";

			foreach (Company comp in treeView.ItemsSource)
			{
				if (comp.Name == searchItem)
				{
					path = comp.Name;
					RadTreeViewItem targetItem = treeView.GetItemByPath(path);
					if (targetItem != null)
					{
						targetItem.IsExpanded = true;
						targetItem.IsSelected = true;
					}
				}

				foreach (Department dept in comp.Departments)
				{
					if (dept.Name == searchItem)
					{
						path = comp.Name + "|" + dept.Name;
						RadTreeViewItem targetItem = treeView.GetItemByPath(path, "|");
						if (targetItem != null)
						{
							targetItem.IsSelected = true;
							targetItem.IsExpanded = true;
						}
					}
					foreach (Employee emp in dept.Employees)
					{
						if (emp.Name == searchItem)
						{
							path = comp.Name + "|" + dept.Name + "|" + emp.Name;
							RadTreeViewItem targetItem = treeView.GetItemByPath(path, "|");
							if (targetItem != null)
							{
								targetItem.IsSelected = true;
								targetItem.IsExpanded = true;
							}
						}
					}
				}
			}

		}

	}
}
